//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_1.cpp		//
// zuletzt getestet:	26.09.01		//
// Betriebssysteme:	Linux			//
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 10		//
// Bisher erreicht:	- p(n,10)<=11 fr alle	//
//			n<=10^1500		//
//			- Potenenzsumme>1500	//
//			- MaxZiffer=??		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
    //cout << vektor1[i] << " ";
  };
  //cout << endl;
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};
inline int min(int a,int b)
{
  if(a<b) return a;
  return b;
};


int main(void)				// Hauptprogramm
{
  // Fr Basis 10
  //
  // Wenn man die kleinsten Zahlen mit Persistence p finden will,
  // so setze man opt=1, und gebe ein:
  // basis=10
  // summe=14
  // und man reproduziert die bekannten Ergebnisse
  //
  // Ansonsten kann man opt=0 setzen

  const int bisher=1500;		// die bisher getestete Exponentensumme
  const int anzahl=115;		// Anzahl der Stellen der Zahlen	
  int basis;			// Die Basis des Stellensystems; hier:10
  int summe;			// Variable fuer die Potenzsumme
  int parameter1=9;		
  int parameter2=8;		// Zur Konstruktion der	
  int parameter3=7;		// verschiedenen Faelle
  int parameter4=2;
  int parameter5=3;
  bool zero;
  bool two;
  bool five;
  int position1,position2,position3,position4,position5;	// Laengen der einzelnen Zahlen
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2],zahl5[anzahl+2];	// Speicherung der einzelnen Zahlen
  int a,b,c,d,e;		// Schleifenvariablen, die die Potenzen der Parameter angeben
  int i;			// Schleifenvariable
  int u,g;
  int max=0;			
  char taste;  			// fuer Eingaben

  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis(10) ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;					// sollte auf 10 gesetzt werden

  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)		// Initialisierung	
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;				// Initialisierung
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=1;a<=1232;a++)
  {
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)		// Mit parameter1 multiplizieren
      zahl1[i]*=parameter1;
    for(i=0;i<=g;i++)		// Ins richtige Stellensystem korrigieren
    {
      u=zahl1[i]/basis;
      zahl1[i]-=u*basis;
      zahl1[i+1]+=u;
    };
    if(position1<anzahl) if(zahl1[position1+1]>0) position1++; 	// Laenger?
  };
  for(a=1233;a<=summe;a++)			// erste Schleife der Potenzsumme
  {
    cout << "[1] " << a << endl;	// Fortschrittsanzeiger
    if(a>0)
    {
      g=min(position1,anzahl);
      for(i=0;i<=g;i++)		// Mit parameter1 multiplizieren
        zahl1[i]*=parameter1;
      for(i=0;i<=g;i++)		// Ins richtige Stellensystem korrigieren
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(position1<anzahl) if(zahl1[position1+1]>0) position1++; 	// Laenger?
      if(a>bisher)
      {
        g=min(position1,anzahl);
        zero=false;
        five=false;
        two=false;
        for(i=0;i<=g;i++)
        {
          if((zahl1[i]%2)==0) two=true;
          if((zahl1[i]%5)==0) five=true;
          if(zahl1[i]==0 || (two==true && five==true))
          {
            zero=true;
            if(i>max) max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "[1] (" << a << ",0,0)" << endl;
          cin  >> taste;
        };
      };
    };
    position2=position1;			// Zwischenergebnis uebernehmen
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)			// zweite Schleife der Potenzsumme
    {
      if(b>0)
      {
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)		// mit Parameter2 multiplizieren
          zahl2[i]*=parameter2;
        for(i=0;i<=g;i++)		// Ins richtige Stellensystem korrigieren
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(position2<anzahl) if(zahl2[position2+1]>0) position2++; 	// laenger?
        if(a+b>bisher)
        {
          g=min(position2,anzahl);
          zero=false;
          five=false;
          two=false;
          for(i=0;i<=g;i++)
          {
            if((zahl2[i]%2)==0) two=true;
            if((zahl2[i]%5)==0) five=true;
            if(zahl2[i]==0 || (two==true && five==true))
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          };
          if(zero==false)
          {
            cout << "[1] (" << a << "," << b << ",0)" << endl;
            cin  >> taste;
          };
        };
      };
      position3=position2;
      g=min(position2,anzahl);
      for(i=0;i<=g;i++)			// Zwischenergebnis uebernehmen
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)			// dritte Schleife der Potenzsumme
      {
        if(c>0)
        {
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)		// mit Parameter3 multiplizieren
            zahl3[i]*=parameter3;
          for(i=0;i<=g;i++)		// Ins richtige Stellensystem korrigieren
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(position3<anzahl) if(zahl3[position3+1]>0) position3++; 	// laenger?
          if(a+b+c>bisher)
          {
            g=min(position3,anzahl);
            zero=false;
            two=false;
            five=false;
            for(i=0;i<=g;i++)
            {
              if((zahl3[i]%2)==0) two=true;
              if((zahl3[i]%5)==0) five=true;
              if(zahl3[i]==0 || (two==true && five==true))
              {
                zero=true;
                if(i>max) max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "[1] (" << a << "," << b << "," << c << ")" << endl;
              cin  >> taste;
            };
          };
        };
        if(a+b+c>bisher)
        {
          position4=position3;
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)			// Zwischenergebnis uebernehmen
            zahl4[i]=zahl3[i];
          for(i=position3+1;i<=anzahl;i++)
            zahl4[i]=0;
          for(d=0;d<=2;d++)		// kleine Schleife fuer zusaetzlichen Faktor
          {
            if(d>0)
            {
              g=min(position4,anzahl);
              for(i=0;i<=g;i++)	// mit Parameter4 multiplizieren
                zahl4[i]*=parameter4;
              for(i=0;i<=g;i++)	// Ins richtige Stellensystem korrigieren
              {
                u=zahl4[i]/basis;
                zahl4[i]-=u*basis;
                zahl4[i+1]+=u;
              };
              if(position4<anzahl) if(zahl4[position4+1]>0) position4++; 	// laenger?
              g=min(position4,anzahl);
              zero=false;
              two=false;
              five=false;
              for(i=0;i<=g;i++)
              {
                if((zahl4[i]%2)==0) two=true;
                if((zahl4[i]%5)==0) five=true;
                if(zahl4[i]==0 || (five==true && two==true))
                {
                  zero=true;
                  if(i>max) max=i;
                  break;
                };
              };
              if(zero==false)
              {
                cout << "[1] (" << a << "," << b << "," << c << ") * ";
                if(d==1) cout << parameter4; else cout << parameter4*parameter4;
                cout << endl;
                cin  >> taste;
              };
            };
            position5=position4;
            g=min(position4,anzahl);
            for(i=0;i<=g;i++)		// Zwischenergebnis uebernehmen
              zahl5[i]=zahl4[i];
            for(i=position4+1;i<=anzahl;i++)
              zahl5[i]=0;
            e=1;
            g=min(position5,anzahl);
            for(i=0;i<=g;i++)		// mit parameter5 multiplizieren
              zahl5[i]*=parameter5;
            for(i=0;i<=g;i++)		// Ins richtige Stellensystem korrigieren
            {
              u=zahl5[i]/basis;
              zahl5[i]-=u*basis;
              zahl5[i+1]+=u;
            };
            if(position5<anzahl) if(zahl5[position5+1]>0) position5++; 	// laenger?
            g=min(position5,anzahl);
            zero=false;
            two=false;
            five=false;
            for(i=0;i<=g;i++)
            {
              if((zahl5[i]%2)==0) two=true;
              if((zahl5[i]%5)==0) five=true;
              if(zahl5[i]==0 || (two==true && five==true))
              {
                zero=true;
                if(i>max) max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "[1] (" << a << "," << b << "," << c << ") * ";
              if(d==1) cout << parameter4*parameter5; else cout << parameter4*parameter4*parameter5;
              cout << endl;
              cin  >> taste;
            };
          };
        };
      };
    };
  };
  
  // #######################################################################
  // #                   zweiter Durchlauf                                 #
  // #######################################################################
  //
  // Da dieser Teil genauso aufgebaut ist, wie der obere
  // wird an dieser Stelle weitesgehend auf die 
  // Kommentierung verzichtet
  parameter1=9;
  parameter2=7;		// neuer Durchlauf
  parameter3=5;		// neue Parameter
  parameter4=3;
  parameter5=0;
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[2] " << a << endl;
    if(a>0)
    {
      g=min(position1,anzahl);
      for(i=0;i<=g;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=g;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(position1<anzahl) if(zahl1[position1+1]>0) position1++;
      if(a>bisher)
      {
        g=min(position1,anzahl);
        zero=false;
        for(i=0;i<=g;i++)
        {
          if((zahl1[i]%2)==0)
          {
            zero=true;
            if(i>max) max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "[1] (" << a << ",0,0)" << endl;
          cin  >> taste;
        };
      };
    };
    position2=position1;
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=g;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(position2<anzahl) if(zahl2[position2+1]>0) position2++;
        if(a+b>bisher)
        {
          g=min(position2,anzahl);
          zero=false;
          for(i=0;i<=g;i++)
            if((zahl2[i]%2)==0)
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          if(zero==false)
          {
            cout << "[1] (" << a << "," << b <<",0)" << endl;
            cin  >> taste;
          };
        };
      };
      position3=position2;
      g=min(position2,anzahl);
      for(i=0;i<=g;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=1;c<=summe-a-b;c++)
      {
        g=min(position3,anzahl);
        for(i=0;i<=g;i++)
          zahl3[i]*=parameter3;
        for(i=0;i<=g;i++)
        {
          u=zahl3[i]/basis;
          zahl3[i]-=u*basis;
          zahl3[i+1]+=u;
        };
        if(position3<anzahl) if(zahl3[position3+1]>0) position3++;
        if(a+b+c>bisher)
        {
          g=min(position3,anzahl);
          zero=false;
          for(i=0;i<=g;i++)
            if((zahl3[i]%2)==0)
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          if(zero==false)
          {
            cout << "[1] (" << a << "," << b << "," << c << ")" << endl;
            cin  >> taste;
          };
          position4=position3;
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)
            zahl4[i]=zahl3[i];
          for(i=position3+1;i<=anzahl;i++)
            zahl4[i]=0;
          g=min(position4,anzahl);
          for(i=0;i<=g;i++)
            zahl4[i]*=parameter4;
          for(i=0;i<=g;i++)
          {
            u=zahl4[i]/basis;
            zahl4[i]-=u*basis;
            zahl4[i+1]+=u;
          };
          if(position4<anzahl) if(zahl4[position4+1]>0) position4++;
          g=min(position4,anzahl);
          zero=false;
          for(i=0;i<=g;i++)
            if((zahl4[i]%2)==0)
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          if(zero==false)
          {
            cout << "[1] (" << a << "," << b << "," << c << ") * " << parameter4 << endl;
            cin  >> taste;
          };
        };
      };
    };
  };
  // #################################################################
  // #                    Fertig                                     #
  // #################################################################


  cout << "Maximale Stellenzahl ohne Null : " << max << endl;
  return 0;
};

