//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_c_s.cpp		//
// zuletzt getestet:	24.09.01		//
// Betriebssysteme:	DOS			//
// Sinn und Zweck:	Scanning von 		//
//			Persistencen mit 3 	//
//			Parametern (Wechsel)    //
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  int u;
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};

int swap(int& a,int& b)
{
  int speicher=a;
  a=b;
  b=speicher;
  return 0;  
};


int main(void)			// Hauptprogramm
{
  // Hier kann man beliebig viele Parameter eingeben.
  // Es werden jedoch nur die verschiedenen Tripel aus
  // diesen Werten durchgespielt.
  //
  // Fuer mehr Kommentare bitte im Referenzfile pers_1.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=150;
  int anzahlverschiedene; 
  int p1,p2,p3;
  int* auswahl;
  int basis;
  int u;
  int summe;
  int rekord;
  int pers;
  int parameter1=5;
  int parameter2=4;
  int parameter3=3;
  int position1,position2,position3;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2];
  int a,b,c;
  int i;
  int max=0;
  int maxa=0,maxb=0,maxc=0;
  int maxsumme=0;
  char taste;
   
  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;
  cout << "Geben Sie den bisherigen Rekord ein:";
  cin  >> rekord;
  cout << "Geben Sie die Anzahl der verschiedenen Parameter (>2) ein:";
  cin  >> anzahlverschiedene;
  auswahl=new int[anzahlverschiedene+1];
  for(i=0;i<anzahlverschiedene;i++)
  {
    cout << "Geben Sie den " << i+1 << "-ten Parameter ein:";
    cin  >> auswahl[i]; 
  };
  for(p1=0;p1<anzahlverschiedene-2;p1++)
  {
  for(p2=p1+1;p2<anzahlverschiedene-1;p2++)
  {
  for(p3=p2+1;p3<anzahlverschiedene;p3++)
  {   
  parameter1=auswahl[p1];
  parameter2=auswahl[p2];
  parameter3=auswahl[p3];
  maxa=0;
  maxb=0;
  maxc=0;
  max=0;

  // die Parameter muessen absteigend sortiert sein
  if(parameter2>parameter1) swap(parameter1,parameter2);
  if(parameter3>parameter1) swap(parameter1,parameter3);
  if(parameter3>parameter2) swap(parameter2,parameter3);  

  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  for(a=0;a<=summe;a++)
  {
    cout << a << endl;
    if(a>0)
    {
      for(i=0;i<=position1;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=position1;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(zahl1[position1+1]>0) position1++;
      if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};
      pers=persistence(zahl1,position1,basis);
      if(pers>2) if(a>maxsumme) maxsumme=a;
      if(pers>max)
      {
        max=pers;
        maxa=a;
        maxb=0;
        maxc=0;
        cout << "(" << a << ",0,0) -> " << pers  << endl;     
      };   
    };
    position2=position1;
    for(i=0;i<=position1;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        for(i=0;i<=position2;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=position2;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(zahl2[position2+1]>0) position2++;
        if(position2>=anzahl){cout << "Ueberlauf" << endl; return -1;};
        pers=persistence(zahl2,position2,basis);
        if(pers>2) if(a+b>maxsumme) maxsumme=a+b; 
        if(pers>max)
        {
          max=pers;
          maxa=a;
          maxb=b;
          maxc=0;
          cout << "(" << a << "," << b << ",0) -> " << pers << endl;  
        };
      };
      position3=position2;
      for(i=0;i<=position2;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=1;c<=summe-a-b;c++)
      {
        for(i=0;i<=position3;i++)
          zahl3[i]*=parameter3;
        for(i=0;i<=position3;i++)
        {
          u=zahl3[i]/basis;
          zahl3[i]-=u*basis;
          zahl3[i+1]+=u;
        };
        if(zahl3[position3+1]>0) position3++;
        if(position3>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
        pers=persistence(zahl3,position3,basis);
        if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
        if(pers>max)
        {
          max=pers;
          maxa=a;
          maxb=b;
          maxc=c;
          cout << "(" << a << "," << b << "," << c << ") -> " << pers << endl;             
        };  
      };
    };
  };
  cout << "Basis: " << basis << endl;
  cout << "Maximale Exponentensumme mit Persistence>2 : " << maxsumme << endl; 
  cout << "Maximale Persistence: " << max << endl;
  cout << "Wird erreicht von : " << parameter1 << "^" << maxa << " * " << parameter2 << "^" << maxb << " * " << parameter3 << "^" << maxc << endl;
  if(max>rekord)
  {
    rekord=max;
    cin  >> taste;
  };

  };};};
  cout << endl << "Rekord: " << rekord << endl;
  return 0;
};

