//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_log.cpp		//
// zuletzt getestet:	26.09.01		//
// Betriebssysteme:	Linux                   //
// Sinn und Zweck:	Ueberpruefen der        //
//			Vermutung p_max(b)>=    //
//                      log_2(b)                //
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl"
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=0;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    };
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2;
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};


int main(void)
{
  int i,e,f,p,grenze;
  int muss;
  int zahl[10000];
  bool stimmt;
  char taste;
  for(i=0;i<10000;i++)
    zahl[i]=0;
  cout << "Persistencen" << endl;
  cout << "============" << endl << endl;
  cout << "Ueberpruefen der Vermutung p_max(b)>=log_3(b)" << endl;
  cout << "Geben Sie die Grenze ein:";
  cin  >> grenze;
  for(i=3;i<=grenze;i+=2)
  {
    if(i%3==0) i+=2;
    muss=int(double(log(i))/double(log(2)));
    stimmt=false;
    for(e=1;e<=20*muss;e++)
    {
      for(f=0;f<e;f++)
        zahl[f]=i-1;
      p=persistence(zahl,e-1,i);
      if(p>=muss)
      {
        stimmt=true;
        cout << i << " : " << muss << " / " << i-1 << "^" << e << " -> " << p << endl;
        break;
      };
    };
    if(stimmt==false)
    {
      cout << "Gegenbeispiel zur Vermutung: " << i << endl;
      cin  >> taste;
    };
  };
  return 0;
};

