//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_1.cpp		//
// zuletzt getestet:	27.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 10		//
// Bisher erreicht:	- p(n,10)<=11 fr alle	//
//			n<=10^1500		//
//			- Potenenzsumme>1500	//
//			- Maxsumme=155		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};


int main(void)				// Hauptprogramm
{
  // Fr Basis 10
  //
  // Wenn man die kleinsten Zahlen mit Persistence p finden will,
  // so setze man opt=1, und gebe ein:
  // basis=10
  // summe=14
  // und man reproduziert die bekannten Ergebnisse
  //
  // Ansonsten kann man opt=0 setzen

  const int anzahl=670;		// Anzahl der Stellen der Zahlen	
  const int opt=0; 		// 0 Optimierung / 1 Normal
  const int super=11;		// Bisheriges aximum, was man ueberbieten moechte
  int u;
  int basis;			// Die Basis des Stellensystems; hier:10
  int summe;			// Variable fuer die Potenzsumme
  int pers;			// Variable, um die Persistence zu speichern
  int parameter1=9;		
  int parameter2=8;		// Zur Konstruktion der	
  int parameter3=7;		// verschiedenen Faelle
  int parameter4=2;
  int parameter5=3; 
  int position1,position2,position3,position4,position5;	// Laengen der einzelnen Zahlen
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2],zahl5[anzahl+2];	// Speicherung der einzelnen Zahlen
  int a,b,c,d,e;		// Schleifenvariablen, die die Potenzen der Parameter angeben
  int i;			// Schleifenvariable
  int max=0;			
  int maxsumme=0;		// Maximale Potenzsumme mit einer Persistence groesser als 2
  char taste;  			// fuer Eingaben
  long double min[20];		// minimale Beispiele
  long double test;		// zur Berechnung der Dezimalzahl hinter den Loesungen
   
  for(i=0;i<20;i++)
    min[i]=-1;
  min[0]=0;			// Formel
 
  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis(10) ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;					// sollte auf 10 gesetzt werden

  min[1]=basis;			// Formel 

  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)		// Initialisierung	
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;				// Initialisierung
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=0;a<=summe;a++)			// erste Schleife der Potenzsumme
  {
    cout << "[1] " << a << endl;	// Fortschrittsanzeiger
    if(a>0)
    {
      for(i=0;i<=position1;i++)		// Mit parameter1 multiplizieren
        zahl1[i]*=parameter1;
      for(i=0;i<=position1;i++)		// Ins richtige Stellensystem korrigieren
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(zahl1[position1+1]>0) position1++; 	// Laenger?
      if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};	// Sicherheitsabfrage
      pers=persistence(zahl1,position1,basis);	// Berechnung der Persistence
      if(pers>2) if(a>maxsumme) maxsumme=a;	// Maxsumme
      if(opt>0)					// Optimierungsschalter
      {
        test=0;
        for(i=0;i<a;i++)			// Berechnung der entsprechenden Dezimalzahl
          test+=parameter1*pow(basis,i); 
        if(min[pers]<0) min[pers]=test;		// minimale Loesungen
        else if(test<min[pers]) min[pers]=test;
        if(pers>max) max=pers;			// maximale Persistence
        if(pers>9 || pers>=max) cout << "(" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;  	// ausgeben der hoeheren Loesungen
        //cin  >> taste;
      };
      if(pers>super)  				// neuer Rekord
      {
        cout << "(" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;  
        cin  >> taste;   
      };
    };
    position2=position1;			// Zwischenergebnis uebernehmen
    for(i=0;i<=position1;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)			// zweite Schleife der Potenzsumme
    {
      if(b>0)
      {
        for(i=0;i<=position2;i++)		// mit Parameter2 multiplizieren
          zahl2[i]*=parameter2;
        for(i=0;i<=position2;i++)		// Ins richtige Stellensystem korrigieren
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(zahl2[position2+1]>0) position2++; 	// laenger?
        if(position2>=anzahl){cout << "Ueberlauf" << endl; return -1;};	// Sicherheitsabfrage
        pers=persistence(zahl2,position2,basis);	// Persistence berechnen
        if(pers>2) if(a+b>maxsumme) maxsumme=a+b; 	// Maxsumme
        if(opt>0)					// Optimierungsschalter
        {
          test=0;
          for(i=0;i<a;i++)				// Berechnung der entsprechenden Dezimalzahl
            test+=parameter1*pow(basis,i); 
          for(i=0;i<b;i++)
            test+=parameter2*pow(basis,i+a); 
          if(min[pers]<0) min[pers]=test;		// minimale Loesungen
          else if(test<min[pers]) min[pers]=test;
          if(pers>max) max=pers;			// maximale Persistence
          if(pers>9 || pers>=max) cout << "(" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  	// Ausgabe der hoeheren Loesungen
          //cin  >> taste; 
        };
        if(pers>super)  			// neuer Rekord
        {
          cout << "(" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  
          cin  >> taste;   
        };   
      };
      position3=position2;
      for(i=0;i<=position2;i++)			// Zwischenergebnis uebernehmen
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)			// dritte Schleife der Potenzsumme
      {
        if(c>0)
        {
          for(i=0;i<=position3;i++)		// mit Parameter3 multiplizieren
            zahl3[i]*=parameter3;
          for(i=0;i<=position3;i++)		// Ins richtige Stellensystem korrigieren
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(zahl3[position3+1]>0) position3++; 	// laenger?
          if(position3>=anzahl){cout << "Ueberlauf" << endl; return -1;};  	// Sicherheitsabfrage
          pers=persistence(zahl3,position3,basis);	// Persistence berechnen
          if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;	// Maxsumme
          if(opt>0)					// Optimierungsschalter
          {
            test=0;
            for(i=0;i<a;i++)				// Berechnung der entsprechenden Dezimalzahl
              test+=parameter1*pow(basis,i); 
            for(i=0;i<b;i++)
              test+=parameter2*pow(basis,i+a); 
            for(i=0;i<c;i++)
              test+=parameter3*pow(basis,i+b+a); 
            if(min[pers]<0) min[pers]=test;		// minimale Loesungen	
            else if(test<min[pers]) min[pers]=test;
            if(pers>max) max=pers;			// maximale Persistence
            if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 	// Ausgabe der hoeheren Loesungen
            //cin  >> taste;  
          };
          if(pers>super)  				// neuer Rekord
          {
            cout << "(" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            cin  >> taste;   
          }; 
        };
        position4=position3;
        for(i=0;i<=position3;i++)			// Zwischenergebnis uebernehmen
          zahl4[i]=zahl3[i];
        for(i=position3+1;i<=anzahl;i++)
          zahl4[i]=0;   
        for(d=0;d<=2;d++)		// kleine Schleife fuer zusaetzlichen Faktor
        {
          if(d>0)
          {
            for(i=0;i<=position4;i++)	// mit Parameter4 multiplizieren
              zahl4[i]*=parameter4;
            for(i=0;i<=position4;i++)	// Ins richtige Stellensystem korrigieren
            {
              u=zahl4[i]/basis;
              zahl4[i]-=u*basis;
              zahl4[i+1]+=u;
            };
            if(zahl4[position4+1]>0) position4++; 	// laenger?
            if(position4>=anzahl){cout << "Ueberlauf" << endl; return -1;};  // Sicherheitsabfrage
            pers=persistence(zahl4,position4,basis);	// Persistence berechnen
            if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c; 	// Maxsumme
            if(opt>0)					// Optimierungsschalter
            {
              test=0;
              for(i=0;i<a;i++)			// Berechnung der entsprechenden Dezimalzahl	
                test+=parameter1*pow(basis,i); 
              for(i=0;i<b;i++)
                test+=parameter2*pow(basis,i+a); 
              for(i=0;i<c;i++)
                test+=parameter3*pow(basis,i+b+a); 
              test+=pow(parameter4,d)*pow(basis,b+a+c);      
              if(min[pers]<0) min[pers]=test;		// minimale Loesungen
              else if(test<min[pers]) min[pers]=test;
              if(pers>max) max=pers;			// maximale Persistence
              if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d) << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 	// Ausgabe der hoeheren Loesungen
              //cin  >> taste;  
            };
            if(pers>super)  			// neuer Rekord
            {
              cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d) << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
              cin  >> taste;   
            }; 
          };     
          position5=position4;
          for(i=0;i<=position4;i++)		// Zwischenergebnis uebernehmen
            zahl5[i]=zahl4[i];
          for(i=position4+1;i<=anzahl;i++)
            zahl5[i]=0;   
          e=1;
          for(i=0;i<=position5;i++)		// mit parameter5 multiplizieren
            zahl5[i]*=parameter5;
          for(i=0;i<=position5;i++)		// Ins richtige Stellensystem korrigieren
          {
            u=zahl5[i]/basis;
            zahl5[i]-=u*basis;
            zahl5[i+1]+=u;
          };
          if(zahl5[position5+1]>0) position5++; 	// laenger?
          if(position5>=anzahl){cout << "Ueberlauf" << endl; return -1;};  	// Sicherheitsabfrage
          pers=persistence(zahl5,position5,basis);	// Persistence berechnen
          if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;	// Maxsumme
          if(opt>0) 				// Optimierungsschalter
          {
            test=0;
            for(i=0;i<a;i++)			// Berechnen der entsprechenden Dezimalzahl
              test+=parameter1*pow(basis,i); 
            for(i=0;i<b;i++)
              test+=parameter2*pow(basis,i+a); 
            for(i=0;i<c;i++)
              test+=parameter3*pow(basis,i+b+a); 
            if(d<=1) test+=pow(parameter4,d)*parameter5*pow(basis,b+a+c);      
            else test+=(parameter4*basis+parameter4*parameter5)*pow(basis,b+a+c); 
            if(min[pers]<0) min[pers]=test;		// minimale Loesungen
            else if(test<min[pers]) min[pers]=test;
            if(pers>max) max=pers;			// maximale Persistence
            if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d)*parameter5 << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 	// Ausgabe der hoeheren Loesungen
            //cin  >> taste;  
          };
          if(pers>super)  		// neuer Rekord
          {
            cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d)*parameter5 << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            cin  >> taste;   
          }; 
        };
      };
    };
  };
  
  // #######################################################################
  // #                   zweiter Durchlauf                                 #
  // #######################################################################
  //
  // Da dieser Teil genauso aufgebaut ist, wie der obere
  // wird an dieser Stelle weitesgehend auf die 
  // Kommentierung verzichtet
  parameter1=9;
  parameter2=7;		// neuer Durchlauf
  parameter3=5;		// neue Parameter
  parameter4=3;
  parameter5=0;
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[2] " << a << endl;
    if(a>0)
    {
      for(i=0;i<=position1;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=position1;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(zahl1[position1+1]>0) position1++;
      if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};
      pers=persistence(zahl1,position1,basis);
      if(pers>2) if(a>maxsumme) maxsumme=a;
      if(opt>0)
      {
        test=0;
        for(i=0;i<a;i++)
          test+=parameter1*pow(basis,i); 
        if(min[pers]<0) min[pers]=test;
        else if(test<min[pers]) min[pers]=test;
        if(pers>max) max=pers;
        if(pers>9 || pers>=max) cout << "[2](" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;  
        //cin  >> taste;
      };
      if(pers>super)  
      {
        cout << "[2](" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;   
        cin  >> taste;   
      };   
    };
    position2=position1;
    for(i=0;i<=position1;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        for(i=0;i<=position2;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=position2;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(zahl2[position2+1]>0) position2++;
        if(position2>=anzahl){cout << "Ueberlauf" << endl; return -1;};
        pers=persistence(zahl2,position2,basis);
        if(pers>2) if(a+b>maxsumme) maxsumme=a+b; 
        if(opt>0)
        {
          test=0;
          for(i=0;i<a;i++)
            test+=parameter1*pow(basis,i); 
          for(i=0;i<b;i++)
            test+=parameter2*pow(basis,i+a); 
          if(min[pers]<0) min[pers]=test;
          else if(test<min[pers]) min[pers]=test;
          if(pers>max) max=pers;
          if(pers>9 || pers>=max) cout << "[2](" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  
          //cin  >> taste; 
        };
        if(pers>super)  
        {
          cout << "[2](" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  
          cin  >> taste;   
        }; 
      };
      position3=position2;
      for(i=0;i<=position2;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=1;c<=summe-a-b;c++)
      {
        for(i=0;i<=position3;i++)
          zahl3[i]*=parameter3;
        for(i=0;i<=position3;i++)
        {
          u=zahl3[i]/basis;
          zahl3[i]-=u*basis;
          zahl3[i+1]+=u;
        };
        if(zahl3[position3+1]>0) position3++;
        if(position3>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
        pers=persistence(zahl3,position3,basis);
        if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
        if(opt>0)
        {
          test=0;
          for(i=0;i<a;i++)
            test+=parameter1*pow(basis,i); 
          for(i=0;i<b;i++)
            test+=parameter2*pow(basis,i+a); 
          for(i=0;i<c;i++)
            test+=parameter3*pow(basis,i+b+a); 
          if(min[pers]<0) min[pers]=test;
          else if(test<min[pers]) min[pers]=test;
          if(pers>max) max=pers;
          if(pers>9 || pers>=max) cout << "[2](" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
          //cin  >> taste;  
        };
        if(pers>super)  
        {
          cout << "[2](" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
          cin  >> taste;   
        };  
        position4=position3;
        for(i=0;i<=position3;i++)
          zahl4[i]=zahl3[i];
        for(i=position3+1;i<=anzahl;i++)
          zahl4[i]=0; 
        for(i=0;i<=position4;i++)
          zahl4[i]*=parameter4;
        for(i=0;i<=position4;i++)
        {
          u=zahl4[i]/basis;
          zahl4[i]-=u*basis;
          zahl4[i+1]+=u;
        };
        if(zahl4[position4+1]>0) position4++;
        if(position4>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
        pers=persistence(zahl4,position4,basis);
        if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
        if(opt>0)
        {
          test=0;
          for(i=0;i<a;i++)
            test+=parameter1*pow(basis,i); 
          for(i=0;i<b;i++)
            test+=parameter2*pow(basis,i+a); 
          for(i=0;i<c;i++)
            test+=parameter3*pow(basis,i+b+a); 
          test+=parameter4*pow(basis,a+b+c); 
          if(min[pers]<0) min[pers]=test;
          else if(test<min[pers]) min[pers]=test;
          if(pers>max) max=pers;
          if(pers>9 || pers>=max) cout << "[2](" << a << "," << b << "," << c << ") * " << parameter4 << " -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
          //cin  >> taste;  
        };   
        if(pers>super)  
        {
          cout << "[2](" << a << "," << b << "," << c << ") * " << parameter4 << " -> " << pers << "   (" << setprecision(20) << test << ")" << endl;      
          cin  >> taste;   
        };  
      };
    };
  };
  // #################################################################
  // #                    Fertig                                     #
  // #################################################################

  for(i=0;i<14;i++)				// Ausgabe der minimalen Loesungen
    cout << i << " : " << setprecision(20) << min[i] << endl;
  cout << endl;
  cout << "Maximale Exponentensumme mit Persistence>2 : " << maxsumme << endl; 
  return 0;
};

