//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_2.cpp		//
// zuletzt getestet:	27.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 9			//
// Bisher erreicht:	- p(n,9)<=7 fr alle	//
//			n<=10^139		//
//			- Potenenzsumme>200	//
//			- Maxsumme=152		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};


int main(void)			// Hauptprogramm
{
  // Fr Basis 9
  //
  // Wenn man die kleinsten Zahlen mit Persistence p finden will,
  // so setze man opt=1, und gebe ein:
  // basis=9
  // summe=6
  // und man reproduziert die bekannten Ergebnisse
  //
  // Ansonsten kann man opt=0 setzen
  //
  //
  // Fuer mehr Kommentare bitte im Referenzfile pers_1.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=960;
  const int opt=0; 		// 0 Optimierung / 1 Normal
  const int super=7;
  int basis;
  int u;
  int summe;
  int pers;
  int parameter1=8;
  int parameter2=7;
  int parameter3=5;
  int parameter4=2;
  int parameter5=3; 
  int position1,position2,position3,position4,position5;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2],zahl5[anzahl+2];
  int a,b,c,d,e;
  int i;
  int max=0;
  int maxsumme=0;
  char taste;  
  long double min[20];
  long double test;
   
  for(i=0;i<20;i++)
    min[i]=-1;
  min[0]=0;			// Formel
 
  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis(9) ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;

  min[1]=basis;			// Formel 

  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[1] " << a << endl;
    if(a>0)
    {
      for(i=0;i<=position1;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=position1;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(zahl1[position1+1]>0) position1++;
      if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};
      pers=persistence(zahl1,position1,basis);
      if(pers>2) if(a>maxsumme) maxsumme=a;
      if(opt>0)
      {
        test=0;
        for(i=0;i<a;i++)
          test+=parameter1*pow(basis,i); 
        if(min[pers]<0) min[pers]=test;
        else if(test<min[pers]) min[pers]=test;
        if(pers>max) max=pers;
        if(pers>9 || pers>=max) cout << "(" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;  
        //cin  >> taste;
      };
      if(pers>super)  
      {
        cout << "(" << a << ",0,0) -> " << pers  << "   (" << setprecision(20) << test << ")" << endl;  
        cin  >> taste;   
      };
    };
    position2=position1;
    for(i=0;i<=position1;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        for(i=0;i<=position2;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=position2;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(zahl2[position2+1]>0) position2++;
        if(position2>=anzahl){cout << "Ueberlauf" << endl; return -1;};
        pers=persistence(zahl2,position2,basis);
        if(pers>2) if(a+b>maxsumme) maxsumme=a+b; 
        if(opt>0)
        {
          test=0;
          for(i=0;i<a;i++)
            test+=parameter1*pow(basis,i); 
          for(i=0;i<b;i++)
            test+=parameter2*pow(basis,i+a); 
          if(min[pers]<0) min[pers]=test;
          else if(test<min[pers]) min[pers]=test;
          if(pers>max) max=pers;
          if(pers>9 || pers>=max) cout << "(" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  
          //cin  >> taste; 
        };
        if(pers>super)  
        {
          cout << "(" << a << "," << b << ",0) -> " << pers << "   (" << setprecision(20) << test << ")" << endl;  
          cin  >> taste;   
        };   
      };
      position3=position2;
      for(i=0;i<=position2;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)
      {
        if(c>0)
        {
          for(i=0;i<=position3;i++)
            zahl3[i]*=parameter3;
          for(i=0;i<=position3;i++)
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(zahl3[position3+1]>0) position3++;
          if(position3>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
          pers=persistence(zahl3,position3,basis);
          if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
          if(opt>0)
          {
            test=0;
            for(i=0;i<a;i++)
              test+=parameter1*pow(basis,i); 
            for(i=0;i<b;i++)
              test+=parameter2*pow(basis,i+a); 
            for(i=0;i<c;i++)
              test+=parameter3*pow(basis,i+b+a); 
            if(min[pers]<0) min[pers]=test;
            else if(test<min[pers]) min[pers]=test;
            if(pers>max) max=pers;
            if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            //cin  >> taste;  
          };
          if(pers>super)  
          {
            cout << "(" << a << "," << b << "," << c << ") -> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            cin  >> taste;   
          }; 
        };
        position4=position3;
        for(i=0;i<=position3;i++)
          zahl4[i]=zahl3[i];
        for(i=position3+1;i<=anzahl;i++)
          zahl4[i]=0;   
        for(d=0;d<=2;d++)
        {
          if(d>0)
          {
            for(i=0;i<=position4;i++)
              zahl4[i]*=parameter4;
            for(i=0;i<=position4;i++)
            {
              u=zahl4[i]/basis;
              zahl4[i]-=u*basis;
              zahl4[i+1]+=u;
            };
            if(zahl4[position4+1]>0) position4++;
            if(position4>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
            pers=persistence(zahl4,position4,basis);
            if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c; 
            if(opt>0)
            {
              test=0;
              for(i=0;i<a;i++)
                test+=parameter1*pow(basis,i); 
              for(i=0;i<b;i++)
                test+=parameter2*pow(basis,i+a); 
              for(i=0;i<c;i++)
                test+=parameter3*pow(basis,i+b+a); 
              test+=pow(parameter4,d)*pow(basis,b+a+c);      
              if(min[pers]<0) min[pers]=test;
              else if(test<min[pers]) min[pers]=test;
              if(pers>max) max=pers;
              if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d) << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
              //cin  >> taste;  
            };
            if(pers>super)  
            {
              cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d) << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
              cin  >> taste;   
            }; 
          };     
          position5=position4;
          for(i=0;i<=position4;i++)
            zahl5[i]=zahl4[i];
          for(i=position4+1;i<=anzahl;i++)
            zahl5[i]=0;   
          e=1;
          for(i=0;i<=position5;i++)
            zahl5[i]*=parameter5;
          for(i=0;i<=position5;i++)
          {
            u=zahl5[i]/basis;
            zahl5[i]-=u*basis;
            zahl5[i+1]+=u;
          };
          if(zahl5[position5+1]>0) position5++;
          if(position5>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
          pers=persistence(zahl5,position5,basis);
          if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
          if(opt>0) 
          {
            test=0;
            for(i=0;i<a;i++)
              test+=parameter1*pow(basis,i); 
            for(i=0;i<b;i++)
              test+=parameter2*pow(basis,i+a); 
            if(d>0)
            {
              test+=parameter4*parameter5*pow(basis,b+a);
              for(i=0;i<c;i++)
                test+=parameter3*pow(basis,i+b+a+1);   
              if(d==2) test+=parameter4*pow(basis,a+b+c+1);   
            }
            else
            {      
              for(i=0;i<c;i++)
                test+=parameter3*pow(basis,i+b+a); 
              if(d<=1) test+=pow(parameter4,d)*parameter5*pow(basis,b+a+c);      
              else test+=(parameter4*basis+parameter4*parameter5)*pow(basis,b+a+c); 
            };  
            if(min[pers]<0) min[pers]=test;
            else if(test<min[pers]) min[pers]=test;
            if(pers>max) max=pers;
            if(pers>9 || pers>=max) cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d)*parameter5 << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            //cin  >> taste;  
          };
          if(pers>super)  
          {
            cout << "(" << a << "," << b << "," << c << ") * " << pow(parameter4,d)*parameter5 << "-> " << pers << "   (" << setprecision(20) << test << ")" << endl; 
            cin  >> taste;   
          }; 
        };
      };
    };
  };
  
  
  for(i=0;i<10;i++)
    cout << i << " : " << setprecision(20) << min[i] << endl;
  cout << endl;
  cout << "Maximale Exponentensumme mit Persistence>2 : " << maxsumme << endl; 
  return 0;
};

