//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_a.cpp		//
// zuletzt getestet:	26.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen mit 1 	//
//			Parametern		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};

int swap(int& a,int& b)
{
  int speicher=a;
  a=b;
  b=speicher;
  return 0;  
};


int main(void)			// Hauptprogramm
{
  // Hier kann man einen Parameter beliebig eingeben
  //
  // Fuer mehr Kommentare bitte im Referenzfile pers_1.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=5000;
  int u;
  int basis;
  int summe;
  int pers;
  int parameter1=5;
  int position1;
  int zahl1[anzahl+2];
  int a;
  int i;
  int max=0;
  int maxa=0;
  int maxsumme=0;
  
   
  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;
  cout << "Geben Sie den ersten Parameter ein:";
  cin  >> parameter1;
  

  // die Parameter muessen absteigend sortiert sein
   

  for(i=0;i<=anzahl;i++)
    zahl1[i]=0;
  zahl1[0]=1;
  position1=0;
  for(a=1;a<=summe;a++)
  {
    cout << a << endl;
    for(i=0;i<=position1;i++)
      zahl1[i]*=parameter1;
    for(i=0;i<=position1;i++)
    {
      u=zahl1[i]/basis;
      zahl1[i]-=u*basis;
      zahl1[i+1]+=u;
    };

    if(zahl1[position1+1]>0) position1++; 
    if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};
    pers=persistence(zahl1,position1,basis);
    if(pers>2) if(a>maxsumme) maxsumme=a;
    if(pers>max)
    {
      max=pers;
      maxa=a;
      cout << "(" << a << ") -> " << pers  << endl;     
    };   
  };
  cout << "Basis: " << basis << endl;
  cout << "Maximale Exponentensumme mit Persistence>2 : " << maxsumme << endl; 
  cout << "Maximale Persistence: " << max << endl;
  cout << "Wird erreicht von : " << parameter1 << "^" << maxa << endl;
  return 0;
};

