//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_d.cpp		//
// zuletzt getestet:	26.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen mit 4 	//
//			Parametern		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(int* feld, int position, int base)	// Funktion, um die Persistence zu berechnen
{
  int r=0;				// Rckgabewert
  int u;
  if(position<=0) return 0;		// ist schon einstellig
  int* vektor1;				// erste "Zahl" 
  int* vektor2;				// zweite "Zahl"
  int pos1,pos2;			// entsprechende Stellenzahlen
  vektor1=new int[position+2];		
  vektor2=new int[position+2];
  int i,e;				// Schleifenvariablen
  for(i=0;i<=position;i++)		// erste Zahl initialisieren
  {
    vektor1[i]=feld[i];
  };
  pos1=position;			
  r=1;					// Anfang, da 0 schon ausgeschlossen
  while(pos1>0)
  {
    pos2=0;
    for(i=1;i<=position+1;i++)		// Initialisiere die zweite
      vektor2[i]=0;
    vektor2[0]=1;			// Zahl auf 1
    for(e=0;e<=pos1;e++)
    {
      if(vektor1[e]==0)			// alles mit Null multiplizieren => nchste Zahl ist einstellig
      {
        r++;				// erst im nchsten Schritt einstellig
        goto rueckgabe;        
      };
      for(i=0;i<=pos2;i++)
        vektor2[i]*=vektor1[e];   	// Mit weiterer Ziffer multiplizieren
      for(i=0;i<=pos2;i++)		// Ueberlaeufer korrigieren
      {
        u=vektor2[i]/base;
        vektor2[i]-=u*base;
        vektor2[i+1]+=u;
      };
      if(vektor2[pos2+1]>0) pos2++;	// Ist die Zahl laenger geworden?
    }; 
    for(i=0;i<=pos2;i++)		// Fuer naechsten Durchlauf vorbereiten
    {
      vektor1[i]=vektor2[i];
    };
    for(i=pos2+1;i<=position+1;i++)	// restliche Stellen auf 0 setzen
      vektor1[i]=0;
    pos1=pos2; 
    r++;				// Persistence hat sich erhoeht
  };
rueckgabe:  delete[] vektor1;		// Speicherplatz wieder freigeben
  delete[] vektor2;			// Speicherplatz wieder freigeben
  return r;
};

int swap(int& a,int& b)
{
  int speicher=a;
  a=b;
  b=speicher;
  return 0;  
};


int main(void)			// Hauptprogramm
{
  // Hier kann man vier Parameter beliebig eingeben
  //
  // Fuer mehr Kommentare bitte im Referenzfile pers_1.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=300;
  int u;
  int basis;
  int summe;
  int pers;
  int parameter1=5;
  int parameter2=4;
  int parameter3=3;
  int parameter4=2;
  int position1,position2,position3,position4;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2];
  int a,b,c,d;
  int i;
  int max=0;
  int maxa=0,maxb=0,maxc=0,maxd=0;
  int maxsumme=0;
    
   
  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Geben Sie die Basis ein:" << endl;
  cin  >> basis;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;
  cout << "Geben Sie den ersten Parameter ein:";
  cin  >> parameter1;
  cout << "Geben Sie den zweiten Parameter ein:";
  cin  >> parameter2;
  cout << "Geben Sie den dritten Parameter ein:";
  cin  >> parameter3;
  cout << "Geben Sie den vierten Parameter ein:";
  cin  >> parameter4;

  // die Parameter muessen absteigend sortiert sein
  if(parameter2>parameter1) swap(parameter1,parameter2);
  if(parameter3>parameter1) swap(parameter1,parameter3);
  if(parameter4>parameter1) swap(parameter1,parameter4);
  if(parameter3>parameter2) swap(parameter2,parameter3);  
  if(parameter4>parameter2) swap(parameter2,parameter4);
  if(parameter4>parameter3) swap(parameter4,parameter3);    
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  for(a=0;a<=summe;a++)
  {
    cout << a << endl;
    if(a>0)
    {
      for(i=0;i<=position1;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=position1;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(zahl1[position1+1]>0) position1++;
      if(position1>=anzahl){cout << "Ueberlauf" << endl; return -1;};
      pers=persistence(zahl1,position1,basis);
      if(pers>2) if(a>maxsumme) maxsumme=a;
      if(pers>max)
      {
        max=pers;
        maxa=a;
        maxb=0;
        maxc=0;
        maxd=0;
        cout << "(" << a << ",0,0,0) -> " << pers  << endl;     
      };   
    };
    position2=position1;
    for(i=0;i<=position1;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        for(i=0;i<=position2;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=position2;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(zahl2[position2+1]>0) position2++;
        if(position2>=anzahl){cout << "Ueberlauf" << endl; return -1;};
        pers=persistence(zahl2,position2,basis);
        if(pers>2) if(a+b>maxsumme) maxsumme=a+b; 
        if(pers>max)
        {
          max=pers;
          maxa=a;
          maxb=b;
          maxc=0;
          maxd=0; 
          cout << "(" << a << "," << b << ",0,0) -> " << pers << endl;  
        };
      };
      position3=position2;
      for(i=0;i<=position2;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)
      {
        if(c>0)
        {
          for(i=0;i<=position3;i++)
            zahl3[i]*=parameter3;
          for(i=0;i<=position3;i++)
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(zahl3[position3+1]>0) position3++;
          if(position3>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
          pers=persistence(zahl3,position3,basis);
          if(pers>2) if(a+b+c>maxsumme) maxsumme=a+b+c;
          if(pers>max)
          {
            max=pers;
            maxa=a;
            maxb=b;
            maxc=c;
            maxd=0; 
            cout << "(" << a << "," << b << "," << c << ",0) -> " << pers << endl;             
          };  
        };
        position4=position3;
        for(i=0;i<=position3;i++)
          zahl4[i]=zahl3[i];
        for(i=position3+1;i<=anzahl;i++)
          zahl4[i]=0;
        for(d=1;d<=summe-a-b-c;d++)
        {
          for(i=0;i<=position4;i++)
            zahl4[i]*=parameter4;
          for(i=0;i<=position4;i++)
          {
            u=zahl4[i]/basis;
            zahl4[i]-=u*basis;
            zahl4[i+1]+=u;
          };
          if(zahl4[position4+1]>0) position4++;
          if(position4>=anzahl){cout << "Ueberlauf" << endl; return -1;};  
          pers=persistence(zahl4,position4,basis);
          if(pers>2) if(a+b+c+d>maxsumme) maxsumme=a+b+c+d;
          if(pers>max)
          {
            max=pers;
            maxa=a;
            maxb=b;
            maxc=c;
            maxd=d; 
            cout << "(" << a << "," << b << "," << c << "," << d << ") -> " << pers << endl;             
          };  
        };
      };  
    };
  };
  cout << "Basis: " << basis << endl;
  cout << "Maximale Exponentensumme mit Persistence>2 : " << maxsumme << endl; 
  cout << "Maximale Persistence: " << max << endl;
  cout << "Wird erreicht von : " << parameter1 << "^" << maxa << " * " << parameter2 << "^" << maxb << " * " << parameter3 << "^" << maxc << " * " << parameter4 << "^" << maxd << endl;
  return 0;
};

